/*
Copyright Catalin-Alexandru AVRAM
distributed under GNU license agreement
for more information on the GNU license visit www.gnu.org

Functions and variables that should be used from the outside:
friendUID - the user id of the person you are conected with, null if not available
friendstimer - variable to acces the timer from outside
changeView (mainViewName,friendsViewName,showFriends)
	mainViewName - the name of the div containing your main area - must be declared prior to calling the function
	friendsViewName - the name of a div which will be used to show your friend - must also be declared before - any children will be lost
	showFriends - true will hide the main area and show the friends div while false will do the opposite
	
The function OnReceiveTalkData(from,data) should be the only one in need of change to suit your program's need
*/

//Global variables

var friendUID=null;
var uniqueID="BeanCups - by Catalin-Alexandru AVRAM"		//set in order not to interfere with other multiplayer programs (no : please)
var friends = null;
var friendscroll=0;
var friendstimer=null;
var friendstimeraux=null;
var friendlabels=new Array(6);
var friendimages=new Array(6);
var friendivs=new Array(6);
googleTalk.onReceiveTalkData = OnReceiveTalkData;

//Main functions

function refreshFriends(friendsViewName){
	friends=googleTalk.friends.toArray();
	if (friendstimeraux==null){
		friendsViewName.appendElement('<div name="scroll_bar" width="15" height="90" x="250" y="5"><img width="15" height="90" x="0" y="0" src="images/multiplayer/scroll_bkg.png"/><button width="13" height="13" x="1" y="1" image="images/multiplayer/scroll_up.png" overImage="images/multiplayer/scroll_up_over.png" downImage="images/multiplayer/scroll_up_down.png" tooltip="Up" onclick="scrollUp()"/><button width="13" height="13" x="1" y="77" image="images/multiplayer/scroll_down.png" overImage="images/multiplayer/scroll_down_over.png" downImage="images/multiplayer/scroll_down_down.png" tooltip="Down" onclick="scrollDown()"/><img name="scroll_ball" width="11" height="4" x="2" y="16" src="images/multiplayer/scroll_ball.png"/></div>');
		friendsViewName.appendElement('<div name="friend_list" width="245" height="100" x="0" y="0"/>');
		friendsViewName.appendElement('<label name="no_friends_online" width="240" height="30" x="65" y="35" color="#000000" font="Arial" size="12" bold="true">No Friends Online</label>');
		for (i=0;i<6;i++) friend_list.appendElement('<div name="friendiv'+i+'" onclick="selectFriend('+i+')" cursor="hand" enabled="true" onmouseover="friendOver()" onmouseout="friendOut()" width="245" height="15" x="0" y="'+i*15+'"><img name="friendimage'+i+'" src="" x="7" y="0" /><label name="friend'+i+'" x="23" y="0" width="222" height="15" color="#000000" font="Arial" size="9" bold="true"></label></div>');
		friendlabels[0]=friend0;friendlabels[1]=friend1;friendlabels[2]=friend2;friendlabels[3]=friend3;friendlabels[4]=friend4;friendlabels[5]=friend5;
		friendimages[0]=friendimage0;friendimages[1]=friendimage1;friendimages[2]=friendimage2;friendimages[3]=friendimage3;friendimages[4]=friendimage4;friendimages[5]=friendimage5;
		friendivs[0]=friendiv0;friendivs[1]=friendiv1;friendivs[2]=friendiv2;friendivs[3]=friendiv3;friendivs[4]=friendiv4;friendivs[5]=friendiv5;
	}
	if (friends.length>0) for (i=0; i < friends.length; i++) if (!friends[i].has_sidebar){
		friends.splice(i,1);
		i--;
	}
	if (friends.length>6) scroll_bar.visible="true"; else scroll_bar.visible="false";
	if (friends.length>0){
		no_friends_online.visible="false";
		friend_list.visible="true";
		if (friends.length>6 && friends.length<friendscroll+6) friendscroll=friends.length-6;
		setBallY();
		for (i=0;i<6;i++){
			if (i+friendscroll<friends.length){
				friendimages[i].src="images/multiplayer/"+(friends[i+friendscroll].status==gddFriendStatusOnline?"available":friends[i+friendscroll].status==gddFriendStatusBusy?"busy":"away")+".gif";
				friendlabels[i].innerText=friends[i+friendscroll].name;
				friendivs[i].visible="true";
			}else friendivs[i].visible="false";
		}
	}else{
		no_friends_online.visible="true";
		friend_list.visible="false";
	}
	friendstimeraux=friendsViewName;
	friendstimer=setTimeout("refreshFriends(friendstimeraux)",10000);
}
function changeView(mainViewName,friendsViewName,showFriends){
	if (showFriends) {
		mainViewName.visible=false;
		refreshFriends(friendsViewName);
		friendsViewName.visible=true;
		friendUID=null
	}else{
		friendstimer=null;
		friendsViewName.visible=false;
		mainViewName.visible=true;
	}
}
function setBallY(){
	scroll_ball.y=Math.round(friendscroll*55/(friends.length-6))+16;
}

//Event functions

function friendOver(){
	event.srcElement.background = "#ccccff";
}
function friendOut(){
	event.srcElement.background = "";
}
function selectFriend(nr){
	var name=friends[friendscroll+nr].name;
	var id=friends[friendscroll+nr].user_id;
	if (confirm("Are you sure you want to invite "+name+" to play with you ?")){
		try {
			friendUID = id;
			googleTalk.SendTalkData(id, uniqueID+":invite");
		}catch (e){
			friendUID=null;
			alert("Error : \nCould not connect with "+name+" !\nTry again later or choose another friend.");
		}
	}
}
function scrollUp(){
	if (friendscroll>0){
		friendscroll--;
		clearInterval(friendstimer);
		refreshFriends(friendstimeraux);
	}
}
function scrollDown(){
	if (friendscroll<friends.length-6){
		friendscroll++;
		clearInterval(friendstimer);
		refreshFriends(friendstimeraux);
	}
}
function OnReceiveTalkData(friend, data){
	if (data==uniqueID+":invite"){
		if (confirm(friend.name + " wants to play a game of BeanCups with you.\nWould you like to play with him now ? (refusing will allow you to add a reason).\nKeep in mind that any game in progress will be forfeited !")){
			friendUID = friend.user_id;
			googleTalk.SendTalkData(friendUID,uniqueID+":accept");
			changeView(mainarea,friendsarea,false);
			blockInput=false;
			setStartingPosition();
		}else	googleTalk.SendTalkData(friend.user_id,uniqueID+"decline-reason:"+utils.prompt("Give "+friend.name+" a reson for refusing...","I am currently busy"));
	}else if(data==uniqueID+":accept"){
		if (friendUID==friend.user_id){
			changeView(mainarea,friendsarea,false);
			setStartingPosition();
			blockInput=true;
		}else googleTalk.SendTalkData(friend.user_id,uniqueID+":quit");
	}else if(data.match("decline-reason:")){
		if (friendUID==friend.user_id){
			var daux=data.split(":");
			alert(friend.name+" doesn't want to play BeanCups now.\nHis reason is : "+daux[1]);
			changeView(mainarea,friendsarea,true);
		}
	}else if(data==uniqueID+":quit"){
		alert(friend.name+" has quit the game !");
		friendUID=null;
		changeView(mainarea,friendsarea,true);
	}else if(data.match("move:")){
		if (friendUID==friend.user_id){
			var daux=data.split(":");
			daux=7+parseInt(daux[1],10);
			for (i=0;i<48;i++) if (beans[i].tooltip==daux) moveBean(i,0,false);
			bowls[daux].tooltip="0";
			timerparam=daux+1;
			makeEnemyMoves(timerparam);
		}
	}else if(data==uniqueID+":confirmmove"){
		status_bar.innerText="You get an extra move !";
		blockInput=false;
	}
}

//Main program entry point - restrict to multiplayer related operations please
